//-------------------------------------------------------------------------------
// FILE: SAMPLE18.CPP
//
// Aug 98 sample for How Do I in OS/2 e-Zine!
//
// Created by Eric Slaats
// File created with Smalled 2.00.01a
//-------------------------------------------------------------------------------
#define  INCL_WIN
#include <os2.h>

#include "sample18.h"

//-------------------------------------------------------------------------------
//Dialog Window procedure prototype
//-------------------------------------------------------------------------------
MRESULT EXPENTRY DlgProc     ( HWND, ULONG ,MPARAM, MPARAM );
MRESULT EXPENTRY NewEFProc   ( HWND, ULONG, MPARAM, MPARAM ); // subclass for Entryfield
MRESULT EXPENTRY NewLBProc   ( HWND, ULONG, MPARAM, MPARAM ); // subclass for Listbox
MRESULT EXPENTRY NewMLEProc  ( HWND, ULONG, MPARAM, MPARAM ); // subclass for MLE

void    PopupStarter         ( HWND, ULONG, MPARAM );		  // Function  that starts popups.
//-------------------------------------------------------------------------------
// Global vars
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
// Main
//
// Sets up a simple dialogbox to demonstrate that a dialog can act as a main
// window
// By using a dialog none of the usual window control has to be included.
// Everything exept the coupling of the menu is done in a dialog editor.
//-------------------------------------------------------------------------------
void main(void)
	{
	HAB hab = WinInitialize(0);
	HMQ hmq = WinCreateMsgQueue(hab,0);

	WinDlgBox(HWND_DESKTOP,
			HWND_DESKTOP,
			DlgProc,
			NULLHANDLE,
			DIALOG1,
			0);

	WinDestroyMsgQueue(hmq);
	WinTerminate(hab);
	}


//---------------------------------------------------------------------------------
// dialog procedure
//---------------------------------------------------------------------------------
MRESULT EXPENTRY DlgProc(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
	{
	switch (msg)
		{
		//-----------------------------------------------------------------------
		// Handle the initialization of the dialog
		//-----------------------------------------------------------------------
		case WM_INITDLG:
			{
			PFNWP    pfnwOldProc;
			HWND	    hwndControl;
			//------------------------------------------------------------------
			// Subclass the entryfield
			//------------------------------------------------------------------
			hwndControl = WinWindowFromID(hwndDlg, ENTRYFIELD);	    // Get Entryfield HWND
			pfnwOldProc = WinSubclassWindow(hwndControl,NewEFProc);    // subclass Statusbar
			WinSetWindowULong(hwndControl,QWL_USER,(ULONG)pfnwOldProc);// Pointer to oldwinproc in winword
			//------------------------------------------------------------------
			// Subclass the Listbox
			//------------------------------------------------------------------
			hwndControl = WinWindowFromID(hwndDlg, LISTBOX);	   	    // Get lISTBOX HWND
			pfnwOldProc = WinSubclassWindow(hwndControl,NewLBProc);    // subclass Statusbar
			WinSetWindowULong(hwndControl,QWL_USER,(ULONG)pfnwOldProc);// Pointer to oldwinproc in winword
			//------------------------------------------------------------------
			// Subclass the MLE
			//------------------------------------------------------------------
			hwndControl = WinWindowFromID(hwndDlg, MLE);	      	    // Get MLE HWND
			pfnwOldProc = WinSubclassWindow(hwndControl,NewMLEProc);   // subclass Statusbar
			WinSetWindowULong(hwndControl,QWL_USER,(ULONG)pfnwOldProc);// Pointer to oldwinproc in winword
			}
		break;


		//-----------------------------------------------------------------------
		// Handle WM_COMMAND
		//-----------------------------------------------------------------------
		case WM_COMMAND:
			{
			//------------------------------------------------------------------
			// Handle the buttons
			//------------------------------------------------------------------
			switch (SHORT1FROMMP(mp1))
				{
				case 1001: DosBeep(1000,100); break;
				case 1002: DosBeep(2000,100); break;
				case 1003: DosBeep(4000,100); break;
				case 1004: DosBeep(8000,100); break;
				}
			}
		return(0);

		case WM_CONTEXTMENU:
			PopupStarter(hwndDlg, POPUP1, mp1);
		return (MRFROMLONG(TRUE));
		}
	return WinDefDlgProc(hwndDlg, msg, mp1, mp2);
	}




//--------------------------------------------------------------------------------------------------
// NewEFProc
//
// Subclass Entryfield for popup menu
//--------------------------------------------------------------------------------------------------
MRESULT EXPENTRY NewEFProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
	{
	PFNWP oldProc = (PFNWP) WinQueryWindowULong( hwnd, QWL_USER ); // Pointer from windowword
	switch (msg)
		{
		case WM_CONTEXTMENU: PopupStarter(hwnd, ENTRYFPOPUP, mp1); return(MRFROMLONG(TRUE));
		case WM_COMMAND: DosBeep(2000,100); break;
		}	return oldProc(hwnd, msg, mp1, mp2);
	}

//--------------------------------------------------------------------------------------------------
// NewLBProc
//
// Subclass Listbox for popup menu
//--------------------------------------------------------------------------------------------------
MRESULT EXPENTRY NewLBProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
	{
	PFNWP oldProc = (PFNWP) WinQueryWindowULong( hwnd, QWL_USER ); // Pointer from windowword
	switch (msg)
		{
		case WM_CONTEXTMENU: PopupStarter(hwnd, LISTBOXPOPUP, mp1); return(MRFROMLONG(TRUE));
		case WM_COMMAND: DosBeep(1000,100); break;
		}
	return oldProc(hwnd, msg, mp1, mp2);
	}

//--------------------------------------------------------------------------------------------------
// NewMLEProc
//
// Subclass MLE for popup menu
//--------------------------------------------------------------------------------------------------
MRESULT EXPENTRY NewMLEProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
	{
	PFNWP oldProc = (PFNWP) WinQueryWindowULong( hwnd, QWL_USER ); // Pointer from windowword
	switch (msg)
		{
		case WM_CONTEXTMENU: PopupStarter(hwnd, MLEPOPUP, mp1); return(MRFROMLONG(TRUE));
		case WM_COMMAND: DosBeep(500,100);	break;
		}
	return oldProc(hwnd, msg, mp1, mp2);
	}


//-------------------------------------------------------------------------------------------------
// PopupStarter
//
// Proc which starts a specific popup for a specific window.
//-------------------------------------------------------------------------------------------------
void PopupStarter(HWND hwnd, ULONG PopupID, MPARAM mp1)
	{
	HWND hwndPopup;                   				      // popuphandle
	hwndPopup = WinLoadMenu(hwnd, NULLHANDLE, PopupID);  // load popup
	WinPopupMenu(hwnd, hwnd, hwndPopup,                  // Start popup
			   SHORT1FROMMP(mp1),
			   SHORT2FROMMP(mp1),
			   0,
			   PU_HCONSTRAIN | PU_VCONSTRAIN | PU_MOUSEBUTTON1 | PU_KEYBOARD);	
	}
